<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>2048 Game</title>
    <style>
        #game { width: 100% }
        #game table { width: 100% }
        #game table td { width:25%; height: 50px; border: 1px solid #000; text-align: center;
            vertical-align: middle; font-size: 20px; font-weight: bold; }
    </style>
</head>
<body>
    <div id="game"></div>
    <script>
        // 메모리에 게임판 만들기
        var board = [
             [0, 0, 0, 0]
            ,[0, 0, 0, 0]
            ,[0, 0, 0, 0]
            ,[0, 0, 0, 0]
        ]

        // 화면에 보이는 게임판 만들기
        var table = "<table cellspacing='5'>";
        // 화면에 table 행을 추가하기 위한 루프
        for ( let i1 = 0; i1 < 4; i1++ ) {
            // 행 추가시 tr 태그 열기
            table += "<tr>";
            // 열을 추가하기 위한 루프
            for ( let i2 = 0; i2 < 4; i2++ ) {
                // 열 추가시 td 태그 넣기와 각 열에 id 부여하기
                table += "<td id ='" + ( i1 + "x" + i2 ) + "'></td>";
            }
            // 한 열이 끝나면 tr 태그 닫기
            table += "</tr>";
        }
        // 모든 행과 열이 끝나 table 태그 닫기
        table += "</table>";
        // 만들어진 table을 화면에 넣어기
        document.getElementById("game").innerHTML = table;

        // 메모리 게임판을 화면으로 주기적으로 옮기기
        var timer = setInterval( function () {
           for ( let x = 0; x < 4; x++ ) {
               for ( let y = 0; y < 4; y++ ) {
                   // 메모리판의 각 항목이 0이 아니면
                   if ( board[x][y] != 0 ) {
                       // 그 항목의 숫자를 x행 y열에 나타내기
                       document.getElementById(x + 'x' + y).innerHTML = board[x][y];
                   } else { // 그 항목의 숫자가 0이면 빈공간으로 나타내기
                       document.getElementById(x + 'x' + y).innerHTML = "";
                   };
               };
           };
        }, 1000/60 ); // 1/60 초에 한번씩 옮기기 ( 1초당 60번 )
        // 게임 처음 시작화면에 2가 2개가 있는 상태로 시작하기 위해 2번 호출한다.
        makeGame();
        makeGame();

        // 사용자의 방향기로 이동하는 함수 만들기
        // 방향키의 keyCode 를 ev 인자로 받아 이동한다.
        document.addEventListener("keydown", function ( ev ) {
            switch ( ev.keyCode ) {
                // 왼쪽 방향키가 눌린 경우
                case 37:
                    // 숫자를 왼쪽으로 정렬하는 함수 호출
                    moveLeft();
                    // 새로운 2를 게임판에 넣기위해 호출하고 false 이면  게임 끝내기
                    if ( makeGame() == false ) {
                        clearInterval(timer);
                        alert("게임이 끝났습니다!")
                    };
                    break;
                // 위쪽 방향키가 눌린 경우
                case 38:
                    // 숫자를 위쪽으로 정렬하는 함수 호출
                    moveUp();
                    // 새로운 2를 게임판에 넣기위해 호출하고 false 이면  게임 끝내기
                    if ( makeGame() == false ) {
                        clearInterval(timer);
                        alert("게임이 끝났습니다!")
                    };
                    break;
                // 오른쪽 방향키가 눌린 경우
                case 39:
                    // 숫자를 왼쪽으로 정렬하는 함수 호출
                    moveRight();
                    // 새로운 2를 게임판에 넣기위해 호출하고 false 이면  게임 끝내기
                    if ( makeGame() == false ) {
                        clearInterval(timer);
                        alert("게임이 끝났습니다!")
                    };
                    break;
                // 아래쪽 방향키가 눌린 경우
                case 40:
                    // 숫자를 왼쪽으로 정렬하는 함수 호출
                    moveDown();
                    // 새로운 2를 게임판에 넣기위해 호출하고 false 이면  게임 끝내기
                    if ( makeGame() == false ) {
                        clearInterval(timer);
                        alert("게임이 끝났습니다!")
                    };
                    break;
            };
        });

        // 숫자를 왼쪽으로 이동하는 함수
        function moveLeft() {
            // 메모리판을 돌면서
            for ( let x = 0; x < 4; x++ ) {
                for ( let y = 0; y < 4; y++ ) {
                    // 0 인 곳에서
                    if ( board[x][y] == 0 ) {
                        // y 번 다음 열에 있는 숫자가 0 이 아니면
                        for ( let p = y+1; p < 4; p++ ) {
                            if ( board[x][p] != 0 ) {
                                // x행 p열의 것을 x행 y열로 이동한다.
                                board[x][y] = board[x][p];
                                // x행 p열은 0으로 채워준다.
                                board[x][p] = 0;
                                // 이동이 일어나면 다음으로 넘어가기 위해
                                break;
                            };
                        };
                    };
                };
            };
            // 연속된 숫자가 나타나면 더해서 왼쪽으로 이동한다.
            for ( let x = 0; x < 4; x++ ) {
                for ( let y = 0; y < 3; y++ ) {
                    if ( board[x][y] == board[x][y+1] ) {
                        board[x][y] *= 2;
                        board[x][y+1] = 0;
                    };
                };
            };
            // 연속된 숫자를 더 한뒤 다음열 확인하여 2가 있으면 왼쪽으로 이동
            for ( let x = 0; x < 4; x++ ) {
                for ( let y = 0; y < 4; y++ ) {
                    // 0 인 곳에서
                    if ( board[x][y] == 0 ) {
                        // y 번 다음 열에 있는 숫자가 0 이 아니면
                        for ( let p = y+1; p < 4; p++ ) {
                            if ( board[x][p] != 0 ) {
                                // x행 p열의 것을 x행 y열로 이동한다.
                                board[x][y] = board[x][p];
                                // x행 p열은 0으로 채워준다.
                                board[x][p] = 0;
                                // 이동이 일어나면 다음으로 넘어가기 위해
                                break;
                            };
                        };
                    };
                };
            };
        };

        // 숫자를 오른쪽으로 이동하는 함수
        function moveRight() {
            // 메모리판을 돌면서
            for ( let x = 0; x < 4; x++ ) {
                for ( let y = 3; y >= 0; y-- ) {
                    // 0 인 곳에서
                    if ( board[x][y] == 0 ) {
                        // y 번 전열에 있는 숫자가 0 이 아니면
                        for ( let p = y-1; p >= 0; p-- ) {
                            if ( board[x][p] != 0 ) {
                                // x행 p열의 것을 x행 y열로 이동한다.
                                board[x][y] = board[x][p];
                                // x행 p열은 0으로 채워준다.
                                board[x][p] = 0;
                                // 이동이 일어나면 다음으로 넘어가기 위해
                                break;
                            };
                        };
                    };
                };
            };
            // 연속된 숫자가 나타나면 더해서 오른쪽으로 이동한다.
            for ( let x = 0; x < 4; x++ ) {
                for ( let y = 3; y >= 1; y-- ) {
                    if ( board[x][y] == board[x][y-1] ) {
                        board[x][y] *= 2;
                        board[x][y-1] = 0;
                    };
                };
            };
            // 연속된 숫자를 더 한뒤 다음열 확인하여 2가 있으면 오른쪽으로 이동
            for ( let x = 0; x < 4; x++ ) {
                for ( let y = 3; y >= 0; y-- ) {
                    // 0 인 곳에서
                    if ( board[x][y] == 0 ) {
                        // y 번 전열에 있는 숫자가 0 이 아니면
                        for ( let p = y-1; p >= 0; p-- ) {
                            if ( board[x][p] != 0 ) {
                                // x행 p열의 것을 x행 y열로 이동한다.
                                board[x][y] = board[x][p];
                                // x행 p열은 0으로 채워준다.
                                board[x][p] = 0;
                                // 이동이 일어나면 다음으로 넘어가기 위해
                                break;
                            };
                        };
                    };
                };
            };
        };

        // 숫자를 위쪽으로 이동하는 함수
        function moveUp() {
            // 메모리판을 돌면서
            for ( let y = 0; y < 4; y++ ) {
                for ( let x = 0; x < 4; x++ ) {
                    // 0 인 곳에서
                    if ( board[x][y] == 0 ) {
                        // x 번 다음 행에 있는 숫자가 0 이 아니면
                        for ( let p = x+1; p < 4; p++ ) {
                            if ( board[x][p] != 0 ) {
                                // x행 p열의 것을 x행 y열로 이동한다.
                                board[x][y] = board[p][y];
                                // p행 y열은 0으로 채워준다.
                                board[p][y] = 0;
                                // 이동이 일어나면 다음으로 넘어가기 위해
                                break;
                            };
                        };
                    };
                };
            };
            // 연속된 숫자가 나타나면 더해서 위쪽으로 이동한다.
            for ( let y = 0; y < 4; y++ ) {
                for ( let x = 0; x < 3; x++ ) {
                    if ( board[x][y] == board[x+1][y] ) {
                        board[x][y] *= 2;
                        board[x+1][y] = 0;
                    };
                };
            };
            // 연속된 숫자를 더 한뒤 다음행 확인하여 2가 있으면 위쪽으로 이동
            for ( let y = 0; y < 4; y++ ) {
                for ( let x = 0; x < 4; x++ ) {
                    // 0 인 곳에서
                    if ( board[x][y] == 0 ) {
                        // x 번 다음 행에 있는 숫자가 0 이 아니면
                        for ( let p = x+1; p < 4; p++ ) {
                            if ( board[x][p] != 0 ) {
                                // x행 p열의 것을 x행 y열로 이동한다.
                                board[x][y] = board[p][y];
                                // p행 y열은 0으로 채워준다.
                                board[p][y] = 0;
                                // 이동이 일어나면 다음으로 넘어가기 위해
                                break;
                            };
                        };
                    };
                };
            };
        };

        // 숫자를 아래으로 이동하는 함수
        function moveDown() {
            // 메모리판을 돌면서
            for ( let y = 0; y < 4; y++ ) {
                for ( let x = 3; x >= 1; x-- ) {
                    // 0 인 곳에서
                    if ( board[x][y] == 0 ) {
                        // x 번 전행에 있는 숫자가 0 이 아니면
                        for ( let p = x-1; p >= 0; p-- ) {
                            if ( board[p][y] != 0 ) {
                                // p행 y열의 것을 x행 y열로 이동한다.
                                board[x][y] = board[p][y];
                                // p행 y열은 0으로 채워준다.
                                board[p][y] = 0;
                                // 이동이 일어나면 다음으로 넘어가기 위해
                                break;
                            };
                        };
                    };
                };
            };
            // 연속된 숫자가 나타나면 더해서 위쪽으로 이동한다.
            for ( let y = 0; y < 4; y++ ) {
                for ( let x = 3; x >= 1; x-- ) {
                    if ( board[x][y] == board[x-1][y] ) {
                        board[x][y] *= 2;
                        board[x-1][y] = 0;
                    };
                };
            };
            // 연속된 숫자를 더 한뒤 다음행 확인하여 2가 있으면 아래쪽으로 이동
            for ( let y = 0; y < 4; y++ ) {
                for ( let x = 3; x >= 1; x-- ) {
                    // 0 인 곳에서
                    if ( board[x][y] == 0 ) {
                        // x 번 전행에 있는 숫자가 0 이 아니면
                        for ( let p = x-1; p >= 0; p-- ) {
                            if ( board[p][y] != 0 ) {
                                // p행 y열의 것을 x행 y열로 이동한다.
                                board[x][y] = board[p][y];
                                // p행 y열은 0으로 채워준다.
                                board[p][y] = 0;
                                // 이동이 일어나면 다음으로 넘어가기 위해
                                break;
                            };
                        };
                    };
                };
            };
        };


        // 메모리의 게임판에서 빈 공간을 찾아 숫자 2를 넣는 함수
        function makeGame() {
            // 메모리의 게임판을 순회하며 빈 칸을 모두 찾아 저장한다.
            let emptyCells = []; // 빈칸 저장할 배열
            // 행과 열을 순회하기
            for ( let x = 0; x < 4; x++ ) {
                for ( let y = 0; y < 4; y++ ) {
                    // 2 할당시 그 위치에 색을 넣기 위해 먼저 모두 흰색으로 칠한다.
                    document.getElementById(x + 'x' + y).style.background = "white";
                    if ( board[x][y] == 0 ) {
                        emptyCells.push({"x좌표": x, "y좌표": y});
                    };
                };
            };

            // 비어있는 칸이 없으면 게임을 종료하기 위해 false를 리턴한다.
            if ( emptyCells.length == 0 ) {
                return false;
            };

            // 비어있는 칸중에 무작위로 1개를 선택하기 위해 비어있는 칸수로 나누어 나머지를
            // 구하면 0 ~ 15 위치 수를 얻을 수 있다.
            let randomCell = parseInt( Math.random() * 100000 ) % emptyCells.length;
            // 무작위 위치를 사용하여 그 위치의 x 좌표와 y 좌표를 구한다.
            let x = emptyCells[randomCell]["x좌표"];
            let y = emptyCells[randomCell]["y좌표"];
            // 구한 좌표로 메모리 게임판에 2를 할당 한다.
            board[x][y] = 2;
            // 2가 할당된 위치를 표시하기
            document.getElementById(x + 'x' + y).style.background = "red";
            // 2가 추가되어 true 를 리턴한다.
            return true;
        };

    </script>

</body>
</html>